=== debian/control ===
Source: fceux
Section: games
Priority: optional
Maintainer: Joseph Nahmias <jello@debian.org>
Uploaders: Alexander Toresson <alexander.toresson@gmail.com>
Build-Depends:
  debhelper-compat (= 13),
  cmake,
  liblua5.1-0-dev,
  libminizip-dev,
  libqt5opengl5-dev,
  libqwt-qt5-dev,
  libsdl2-dev,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: http://fceux.com/
VCS-Browser: https://salsa.debian.org/games-team/fceux
VCS-Git: https://salsa.debian.org/games-team/fceux.git

Package: fceux
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: efp
Provides: nes-emulator
Description: all-in-one NES/Famicom Emulator
 FCE Ultra X [FCEUX] is an emulator of the original (8-bit) Nintendo
 Entertainment System (NES) released under the GNU General Public License
 (GPL).  It includes the following features (and many more):
 .
       * fully customizable color palette rendering engine
       * complete sound emulation (all five channels)
       * support for up to four joystick controllers
       * zapper emulation for the mouse
       * GameGenie emulation
       * accepts compressed (PKZIP, gzip) ROM images
       * TCP/IP network play
       * Lua scripting
