=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --sourcedirectory=$(CURDIR)/fceux-server/

override_dh_auto_configure: CFLAGS   += -DPUBLIC_RELEASE=1
override_dh_auto_configure: CPPFLAGS += -DPUBLIC_RELEASE=1
override_dh_auto_configure:
	dh_auto_configure -- -DGLVND=1

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --sourcedirectory=$(CURDIR)/fceux-server/

%:
	dh $@
