=== debian/watch ===
# watch file for fceux
# See uscan(1) for format
version=4

# sf.net redirector on qa.debian.org
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1" \
https://sf.net/fceultra/ fceux-(.*)\.src\.tar.(?:bz2|gz) \
  debian gbp import-orig --verbose --uscan
