## fceux 2.5.0+dfsg1

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.1)

project(fceux)

add_subdirectory( src )
