=== src/CMakeLists.txt ===

set( APP_NAME fceux)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if ( ${QT6} )
	message( STATUS "GUI Frontend: Qt6")
	set( Qt Qt6 )
else()
	message( STATUS "GUI Frontend: Qt5")
	set( Qt Qt5 )
endif()

if ( ${QHELP} )
	set(QtHelpModule Help)
	add_definitions( -D_USE_QHELP )
endif()

if ( ${QT6} )
	find_package( Qt6 REQUIRED COMPONENTS Widgets OpenGL OpenGLWidgets ${QtHelpModule})
  	add_definitions( ${Qt6Widgets_DEFINITIONS} ${Qt6Help_DEFINITIONS} ${Qt6OpenGLWidgets_DEFINITIONS} )
  	include_directories( ${Qt6Widgets_INCLUDE_DIRS} ${Qt6Help_INCLUDE_DIRS} ${Qt6OpenGLWidgets_INCLUDE_DIRS} )
else()
	find_package( Qt5 REQUIRED COMPONENTS Widgets OpenGL ${QtHelpModule})
	add_definitions( ${Qt5Widgets_DEFINITIONS} ${Qt5Help_DEFINITIONS} )
	include_directories( ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Help_INCLUDE_DIRS} )
endif()

if(WIN32)
     find_package(OpenGL REQUIRED)
     #find_package(Qt5 COMPONENTS Widgets OpenGL REQUIRED)
     #add_definitions( ${Qt5Widgets_DEFINITIONS}  )
     #include_directories( ${Qt5Widgets_INCLUDE_DIRS} )
     add_definitions( -DMSVC -D_CRT_SECURE_NO_WARNINGS )
     add_definitions( -D__SDL__  -D__QT_DRIVER__  -DQT_DEPRECATED_WARNINGS )
     add_definitions( -DFCEUDEF_DEBUGGER )
     include_directories( ${SDL_INSTALL_PREFIX}/SDL2/include )
     include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib )
     set( OPENGL_LDFLAGS  OpenGL::GL )
     set( SDL2_LDFLAGS  ${SDL_INSTALL_PREFIX}/SDL2/lib/x64/SDL2.lib )
     set( SYS_LIBS  wsock32 ws2_32 vfw32 Htmlhelp )
     set(APP_ICON_RESOURCES_WINDOWS  ${CMAKE_SOURCE_DIR}/icons/fceux.rc )

     if ( ${USE_LIBAV} )
        add_definitions( -D_USE_LIBAV ${LIBAV_CFLAGS} )
        include_directories( ${FFMPEG_INSTALL_PREFIX}/ffmpeg/include )
        set( LIBAV_LDFLAGS  ${FFMPEG_INSTALL_PREFIX}/ffmpeg/lib/avcodec.lib
        	                 ${FFMPEG_INSTALL_PREFIX}/ffmpeg/lib/avformat.lib
                	         ${FFMPEG_INSTALL_PREFIX}/ffmpeg/lib/avutil.lib
                        	 ${FFMPEG_INSTALL_PREFIX}/ffmpeg/lib/swscale.lib
                        	 ${FFMPEG_INSTALL_PREFIX}/ffmpeg/lib/swresample.lib )
     endif()

else(WIN32)
  # Non Windows System
  # UNIX (Linux or Mac OSX)

	if ( ${GLVND} )
		message( STATUS "OpenGL preference: GLVND")
		set (OpenGL_GL_PREFERENCE  GLVND)
	else()
		message( STATUS "OpenGL preference: LEGACY")
		set (OpenGL_GL_PREFERENCE  LEGACY)
	endif()

  # Use the built-in cmake find_package functions to find dependencies
  # Use package PkgConfig to detect headers/library what find_package cannot find.
  find_package(PkgConfig REQUIRED)
  find_package(OpenGL REQUIRED)
  find_package(ZLIB REQUIRED)

  add_definitions( -Wall  -Wno-write-strings  -Wno-sign-compare  -Wno-parentheses  -Wno-unused-local-typedefs  -fPIC )
  add_definitions( -DFCEUDEF_DEBUGGER )

  #if ( ${QT6} )
  #	find_package( Qt6 COMPONENTS Widgets OpenGL OpenGLWidgets REQUIRED)
  #	add_definitions( ${Qt6Widgets_DEFINITIONS} ${Qt6OpenGLWidgets_DEFINITIONS} )
  #	include_directories( ${Qt6Widgets_INCLUDE_DIRS} ${QtOpenGLWidgets_INCLUDE_DIRS} )
  #else()
  #	find_package( Qt5 COMPONENTS Widgets OpenGL REQUIRED)
  #	add_definitions( ${Qt5Widgets_DEFINITIONS}  )
  #	include_directories( ${Qt5Widgets_INCLUDE_DIRS} )
  #endif()
  add_definitions( -D__QT_DRIVER__  -DQT_DEPRECATED_WARNINGS )

  # Check for libminizip
  pkg_check_modules( MINIZIP REQUIRED minizip)

  if ( ${MINIZIP_FOUND} )
	  message( STATUS "Using System minizip ${MINIZIP_VERSION}" )
	  add_definitions( -D_SYSTEM_MINIZIP ${MINIZIP_CFLAGS} )
  endif()

  pkg_check_modules( X264 x264)

  if ( ${X264_FOUND} )
	  message( STATUS "Using System X264 Encoder Library ${X264_VERSION}" )
	  add_definitions( -D_USE_X264 ${X264_CFLAGS} )
  endif()

  pkg_check_modules( X265 x265)

  if ( ${X265_FOUND} )
	  message( STATUS "Using System X265 Encoder Library ${X265_VERSION}" )
	  add_definitions( -D_USE_X265 ${X265_CFLAGS} )
  endif()

  pkg_check_modules( LIBAV  libavcodec  libavformat  libavutil  libswresample  libswscale)

  if ( ${LIBAV_FOUND} )
	  message( STATUS "Using System Libav Library ${LIBAV_VERSION}" )
	  add_definitions( -D_USE_LIBAV ${LIBAV_CFLAGS} )
  endif()

  #pkg_check_modules( GL gl) # Use built in find package instead for OpenGL

  # Check for OpenGL
  if ( ${OPENGL_FOUND} )
	include_directories( ${OPENGL_INCLUDE_DIR} )
  endif()

  # Check for SDL2
  pkg_check_modules( SDL2 REQUIRED sdl2)

  if ( ${SDL2_FOUND} )
	  add_definitions( ${SDL2_CFLAGS} -D__SDL__ )
  endif()

  # Check for LUA
  pkg_search_module( LUA lua5.1 lua-5.1 )

  add_definitions( -DHAVE_ASPRINTF ) # What system wouldn't have this?
  add_definitions( -DLUA_USE_LINUX ) # This needs to be set when link LUA internally for linux and macosx

  if(APPLE)
	set( OPENGL_LDFLAGS  "-framework OpenGL" )
  else()
	set( OPENGL_LDFLAGS  ${OPENGL_LIBRARIES} )
	# OpenBSD  refuses  to  implement  the POSIX  realtime  interface  and
	# refuses to provide a stub library for -ldl
	if(${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
	  	set( SYS_LIBS  -lpthread)
        else()
          	set( SYS_LIBS  -lrt  -lpthread  -ldl)
        endif()
  endif()

endif(WIN32)

if ( ${LUA_FOUND} )
   # Use System LUA
        message( STATUS "Using System Lua ${LUA_VERSION}" )

        add_definitions( -D_S9XLUA_H  ${LUA_CFLAGS} )

        set( LUA_ENGINE_SOURCE  ${CMAKE_CURRENT_SOURCE_DIR}/lua-engine.cpp )

else ()

   # Use Internal LUA
        message( STATUS "Using Internal Lua" )

   add_definitions( -D_S9XLUA_H  -I${CMAKE_CURRENT_SOURCE_DIR}/lua/src )

        set( LUA_ENGINE_SOURCE  
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lapi.c 
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lauxlib.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lbaselib.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lcode.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/ldblib.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/ldebug.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/ldo.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/ldump.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lfunc.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lgc.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/linit.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/liolib.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/llex.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lmathlib.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lmem.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/loadlib.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lobject.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lopcodes.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/loslib.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lparser.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lstate.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lstring.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lstrlib.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/ltable.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/ltablib.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/ltm.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lundump.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lvm.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/lzio.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua/src/print.c
      ${CMAKE_CURRENT_SOURCE_DIR}/lua-engine.cpp 
   )
endif()

if ( ${ZLIB_FOUND} )

  message( STATUS "Using System zlib ${ZLIB_VERSION_STRING}" )
  #add_definitions( ${ZLIB_CFLAGS} )
  include_directories( ${ZLIB_INCLUDE_DIRS} )
else()

   message( STATUS "Using Internal zlib" )

   set( ZLIB_SOURCE 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/adler32.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/compress.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/crc32.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/deflate.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/gzio.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/infblock.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/infcodes.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/inffast.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/inflate.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/inftrees.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/infutil.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/trees.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/uncompr.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/unzip.c 
       ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib/zutil.c 
   	)
endif()

include_directories( ${CMAKE_SOURCE_DIR}/src )
include_directories( ${CMAKE_SOURCE_DIR}/src/drivers )

if(APPLE)
  add_definitions( -DPSS_STYLE=1 )
else(APPLE)
  if(UNIX)
    add_definitions( -DPSS_STYLE=1 )
  endif(UNIX)
endif(APPLE)

set(SRC_CORE
	${CMAKE_CURRENT_SOURCE_DIR}/asm.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/cart.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/cheat.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/conddebug.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/config.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/debug.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/drawing.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/fceu.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/fds.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/file.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/emufile.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/filter.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/ines.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/input.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/movie.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/netplay.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/nsf.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/oldmovie.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/palette.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/ppu.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/sound.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/state.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/unif.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/video.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/vsuni.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/wave.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/x6502.cpp
	${LUA_ENGINE_SOURCE}
	${ZLIB_SOURCE}
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/01-222.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/09-034a.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/103.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/106.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/108.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/112.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/116.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/117.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/120.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/121.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/12in1.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/151.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/156.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/158B.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/15.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/164.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/168.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/170.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/175.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/176.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/177.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/178.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/183.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/185.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/186.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/187.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/189.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/18.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/190.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/193.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/199.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/206.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/208.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/222.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/225.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/228.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/230.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/232.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/234.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/235.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/244.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/246.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/252.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/253.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/28.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/32.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/33.cpp
  	${CMAKE_CURRENT_SOURCE_DIR}/boards/34.cpp
