=== debian/changelog ===
fceux (2.5.0+dfsg1-1) unstable; urgency=medium

  * [cca1097] repack upstream tarball obtained from GH as well
  * [0873fbe] d/watch: look for GitHub releases too
  * [3b8ae10] new upstream release
  * [31364fb] drop patches merged upstream, refresh the rest
  * [92b86ed] bump std-ver; no changes
  * [45a6bf8] d/copyright: remove files deleted by upstream
  * [8840c1e] drop local manpages; they have been merged upstream
  * [124da68] support SOURCE_DATE_EPOCH for build timestamp

 -- Joseph Nahmias <jello@debian.org>  Sun, 21 Nov 2021 20:43:00 -0500
