=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
   libqt5opengl5-dev,
   libqwt-qt5-dev,
   libsdl2-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://fceux.com/
 VCS-Browser: https://salsa.debian.org/games-team/fceux
