=== debian/watch ===
# watch file for fceux
# See uscan(1) for format
version=4

# GitHub
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1" \
  https://github.com/TASVideos/fceux/releases \
  /.*/fceux-(\d[\d.]*)\.tar\.gz \
  debian gbp import-orig --verbose --uscan
