## fceux 2.6.4+dfsg1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+include(GNUInstallDirs)
 
 set( APP_NAME fceux)
 set(CMAKE_AUTOMOC ON)
@@ -111,6 +112,22 @@
   if ( ${LIBAV_FOUND} )
 	  message( STATUS "Using System Libav Library ${LIBAV_VERSION}" )
 	  add_definitions( -D_USE_LIBAV ${LIBAV_CFLAGS} )
+  endif()
+
+  #find_package(X11)
+  pkg_check_modules( X11 x11)
+
+  if ( ${X11_FOUND} )
+	message( STATUS "Has X11 Library ${X11_VERSION}" )
+	add_definitions( -D_HAS_X11 )
+	include_directories( ${X11_INCLUDE_DIR} )
+  endif()
+
+  pkg_check_modules( XKB xkbcommon)
+
+  if ( ${XKB_FOUND} )
+	message( STATUS "Has XKB Library ${XKB_VERSION}" )
+        add_definitions( -D_HAS_XKB ${XKB_CFLAGS} )
   endif()
 
   #pkg_check_modules( GL gl) # Use built in find package instead for OpenGL
@@ -306,12 +323,3 @@
   	${CMAKE_CURRENT_SOURCE_DIR}/boards/230.cpp
   	${CMAKE_CURRENT_SOURCE_DIR}/boards/232.cpp
   	${CMAKE_CURRENT_SOURCE_DIR}/boards/234.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/235.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/244.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/246.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/252.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/253.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/28.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/32.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/33.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/34.cpp
