=== debian/changelog ===
fceux (2.6.4+dfsg1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Joseph Nahmias <jello@debian.org>  Thu, 19 May 2022 09:08:13 -0400

fceux (2.6.4+dfsg1-1) unstable; urgency=medium

  * [67bd672] drop out of date sf.net source location
  * [03d43eb] New upstream version 2.6.4+dfsg1
  * [8c69163] add copyright info for new source files
  * [0a3d31c] update upstream git hash
  * [87d4ae8] drop patch merged upstream
  * [1300dab] refresh patches
  * [6896afb] use UTC for calculating SOURCE_DATE_EPOCH.
    Thanks to Vagrant Cascadian <vagrant@reproducible-builds.org>
    (Closes: #1010463)
  * [fb8a17f] standardize Vcs field spellings
  * [6046861] work around weird interaction between faketime and quilt patch
    this should make the build reproducible in salsa-ci.
    Thanks to Vagrant Cascadian <vagrant@reproducible-builds.org>

 -- Joseph Nahmias <jello@debian.org>  Wed, 18 May 2022 23:15:22 -0400
