=== debian/control ===
--- 
+++ 
@@ -14,8 +14,8 @@
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://fceux.com/
-VCS-Browser: https://salsa.debian.org/games-team/fceux
-VCS-Git: https://salsa.debian.org/games-team/fceux.git
+Vcs-Browser: https://salsa.debian.org/games-team/fceux
+Vcs-Git: https://salsa.debian.org/games-team/fceux.git
 
 Package: fceux
 Architecture: any
