=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,7 @@
 	dh_auto_configure -- -DGLVND=1
 
 override_dh_auto_build:
+	touch -d@$(SOURCE_DATE_EPOCH) fceux.desktop
 	dh_auto_build
 	dh_auto_build --sourcedirectory=$(CURDIR)/fceux-server/
