## fceux 2.6.5+dfsg1

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.8)

project(fceux)

add_subdirectory( src )
