=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,10 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 set(CMAKE_AUTOUIC ON)
+
+if (${PUBLIC_RELEASE})
+	add_definitions( -DPUBLIC_RELEASE=1 )
+endif()
 
 if ( ${QT6} )
 	message( STATUS "GUI Frontend: Qt6")
@@ -28,6 +32,7 @@
 	include_directories( ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Help_INCLUDE_DIRS} )
 endif()
 
+
 if(WIN32)
      find_package(OpenGL REQUIRED)
      #find_package(Qt5 COMPONENTS Widgets OpenGL REQUIRED)
@@ -36,6 +41,8 @@
      add_definitions( -DMSVC -D_CRT_SECURE_NO_WARNINGS )
      add_definitions( -D__SDL__  -D__QT_DRIVER__  -DQT_DEPRECATED_WARNINGS )
      add_definitions( -DFCEUDEF_DEBUGGER )
+     add_definitions( /wd4267 /wd4244 )
+     #add_definitions( /wd4018 ) # Integer comparison sign mismatch warnings
      include_directories( ${SDL_INSTALL_PREFIX}/SDL2/include )
      include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/drivers/win/zlib )
      set( OPENGL_LDFLAGS  OpenGL::GL )
@@ -71,7 +78,8 @@
   find_package(OpenGL REQUIRED)
   find_package(ZLIB REQUIRED)
 
-  add_definitions( -Wall  -Wno-write-strings  -Wno-sign-compare  -Wno-parentheses  -Wno-unused-local-typedefs  -fPIC )
+  add_definitions( -Wall  -Wno-write-strings  -Wno-parentheses  -Wno-unused-local-typedefs  -fPIC )
+  #add_definitions( -Wno-sign-compare )  # Integer comparison sign mismatch warnings
   add_definitions( -DFCEUDEF_DEBUGGER )
 
   #if ( ${QT6} )
@@ -84,6 +92,15 @@
   #	include_directories( ${Qt5Widgets_INCLUDE_DIRS} )
   #endif()
   add_definitions( -D__QT_DRIVER__  -DQT_DEPRECATED_WARNINGS )
+
+  if ( ${ASAN_ENABLE} )
+	add_definitions( -fsanitize=address -fsanitize=bounds-strict )
+	add_definitions( -fsanitize=undefined -fno-sanitize=vptr )
+	set( ASAN_LDFLAGS  -lasan -lubsan)
+	message( STATUS "Address Sanitizer Enabled" )
+  else()
+	message( STATUS "Address Sanitizer Disabled" )
+  endif()
 
   # Check for libminizip
   pkg_check_modules( MINIZIP REQUIRED minizip)
@@ -261,6 +278,7 @@
   	${CMAKE_CURRENT_SOURCE_DIR}/conddebug.cpp
   	${CMAKE_CURRENT_SOURCE_DIR}/config.cpp
   	${CMAKE_CURRENT_SOURCE_DIR}/debug.cpp
+  	${CMAKE_CURRENT_SOURCE_DIR}/debugsymboltable.cpp
   	${CMAKE_CURRENT_SOURCE_DIR}/drawing.cpp
   	${CMAKE_CURRENT_SOURCE_DIR}/fceu.cpp
   	${CMAKE_CURRENT_SOURCE_DIR}/fds.cpp
@@ -310,16 +328,3 @@
   	${CMAKE_CURRENT_SOURCE_DIR}/boards/185.cpp
   	${CMAKE_CURRENT_SOURCE_DIR}/boards/186.cpp
   	${CMAKE_CURRENT_SOURCE_DIR}/boards/187.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/189.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/18.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/190.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/193.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/199.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/206.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/208.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/222.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/225.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/228.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/230.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/232.cpp
-  	${CMAKE_CURRENT_SOURCE_DIR}/boards/234.cpp
