=== attic/cmake-stuff/cmake/cross-mingw32/CMakeLists.txt ===
add_subdirectory(release)
add_subdirectory(debug)
