=== debian/changelog ===
fceux (2.6.5+dfsg1-2) unstable; urgency=medium

  * disable ASAN (Closes: #1031740)

 -- Joseph Nahmias <jello@debian.org>  Tue, 21 Feb 2023 21:14:05 -0500

fceux (2.6.5+dfsg1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
    Changes-By: lintian-brush
    Fixes: lintian: homepage-field-uses-insecure-uri
    See-also: https://lintian.debian.org/tags/homepage-field-uses-insecure-uri.html
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository, Repository-Browse.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-file-is-missing
    See-also: https://lintian.debian.org/tags/upstream-metadata-file-is-missing.html
    Fixes: lintian: upstream-metadata-missing-bug-tracking
    See-also: https://lintian.debian.org/tags/upstream-metadata-missing-bug-tracking.html
    Fixes: lintian: upstream-metadata-missing-repository
    See-also: https://lintian.debian.org/tags/upstream-metadata-missing-repository.html

  [ Joseph Nahmias ]
  * d/watch: update for new upstream tag format
  * New upstream version 2.6.5+dfsg1
  * update upstream copyrights, bump year on debian copyright
  * refresh patches; drop patch merged upstream
  * enable compiler address sanitizer (ASAN)

 -- Joseph Nahmias <jello@debian.org>  Sun, 19 Feb 2023 21:35:04 -0500
