=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
   libsdl2-dev,
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
-Homepage: http://fceux.com/
+Homepage: https://fceux.com/
 Vcs-Browser: https://salsa.debian.org/games-team/fceux
 Vcs-Git: https://salsa.debian.org/games-team/fceux.git
